Bullet Collision Detection & Physics Library: btQuantizedBvhTree Class Reference

Bullet Collision Detection & Physics Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
btQuantizedBvhTree Class Reference

Basic Box tree structure. More...

`#include <btGImpactQuantizedBvh.h>`

Collaboration diagram for btQuantizedBvhTree:
[legend]

## Public Member Functions
| btQuantizedBvhTree ()
void | build_tree (GIM_BVH_DATA_ARRAY &primitive_boxes)
| prototype functions for box tree management
void | quantizePoint (unsigned short *quantizedpoint, const btVector3 &point) const
bool | testQuantizedBoxOverlapp (int node_index, unsigned short *quantizedMin, unsigned short *quantizedMax) const
void | clearNodes ()
int | getNodeCount () const
| node count
bool | isLeafNode (int nodeindex) const
| tells if the node is a leaf
int | getNodeData (int nodeindex) const
void | getNodeBound (int nodeindex, btAABB &bound) const
void | setNodeBound (int nodeindex, const btAABB &bound)
int | getLeftNode (int nodeindex) const
int | getRightNode (int nodeindex) const
int | getEscapeNodeIndex (int nodeindex) const
const BT_QUANTIZED_BVH_NODE * | get_node_pointer (int index=0) const

## Protected Member Functions
void | calc_quantization (GIM_BVH_DATA_ARRAY &primitive_boxes, btScalar boundMargin=btScalar(1.0))
int | _sort_and_calc_splitting_index (GIM_BVH_DATA_ARRAY &primitive_boxes, int startIndex, int endIndex, int splitAxis)
int | _calc_splitting_axis (GIM_BVH_DATA_ARRAY &primitive_boxes, int startIndex, int endIndex)
void | _build_sub_tree (GIM_BVH_DATA_ARRAY &primitive_boxes, int startIndex, int endIndex)

## Protected Attributes
int | m_num_nodes
GIM_QUANTIZED_BVH_NODE_ARRAY | m_node_array
btAABB | m_global_bound
btVector3 | m_bvhQuantization

## Detailed Description

Basic Box tree structure.

Definition at line 36 of file btGImpactQuantizedBvh.h.

## Constructor & Destructor Documentation

## ◆ btQuantizedBvhTree()

btQuantizedBvhTree::btQuantizedBvhTree | ( |  | ) |
| inline

Definition at line 56 of file btGImpactQuantizedBvh.h.

## Member Function Documentation

## ◆ _build_sub_tree()

void btQuantizedBvhTree::_build_sub_tree | ( | GIM_BVH_DATA_ARRAY & | primitive_boxes,
|  | int | startIndex,
|  | int | endIndex
| ) |  |
| protected

Definition at line 169 of file btGImpactQuantizedBvh.cpp.

## ◆ _calc_splitting_axis()

int btQuantizedBvhTree::_calc_splitting_axis | ( | GIM_BVH_DATA_ARRAY & | primitive_boxes,
|  | int | startIndex,
|  | int | endIndex
| ) |  |
| protected

Definition at line 81 of file btGImpactQuantizedBvh.cpp.

## ◆ _sort_and_calc_splitting_index()

int btQuantizedBvhTree::_sort_and_calc_splitting_index | ( | GIM_BVH_DATA_ARRAY & | primitive_boxes,
|  | int | startIndex,
|  | int | endIndex,
|  | int | splitAxis
| ) |  |
| protected

Definition at line 111 of file btGImpactQuantizedBvh.cpp.

## ◆ build_tree()

void btQuantizedBvhTree::build_tree | ( | GIM_BVH_DATA_ARRAY & | primitive_boxes | ) |

prototype functions for box tree management

stackless build tree

Definition at line 216 of file btGImpactQuantizedBvh.cpp.

## ◆ calc_quantization()

void btQuantizedBvhTree::calc_quantization | ( | GIM_BVH_DATA_ARRAY & | primitive_boxes,
|  | btScalar | boundMargin = `btScalar(1.0)`
| ) |  |
| protected

Definition at line 65 of file btGImpactQuantizedBvh.cpp.

## ◆ clearNodes()

void btQuantizedBvhTree::clearNodes | ( |  | ) |
| inline

Definition at line 78 of file btGImpactQuantizedBvh.h.

## ◆ get_node_pointer()

const BT_QUANTIZED_BVH_NODE * btQuantizedBvhTree::get_node_pointer | ( | int | index = `0` | ) | const
| inline

Definition at line 143 of file btGImpactQuantizedBvh.h.

## ◆ getEscapeNodeIndex()

int btQuantizedBvhTree::getEscapeNodeIndex | ( | int | nodeindex | ) | const
| inline

Definition at line 138 of file btGImpactQuantizedBvh.h.

## ◆ getLeftNode()

int btQuantizedBvhTree::getLeftNode | ( | int | nodeindex | ) | const
| inline

Definition at line 127 of file btGImpactQuantizedBvh.h.

## ◆ getNodeBound()

void btQuantizedBvhTree::getNodeBound | ( | int | nodeindex,
|  | btAABB & | bound
| ) |  | const
| inline

Definition at line 101 of file btGImpactQuantizedBvh.h.

## ◆ getNodeCount()

int btQuantizedBvhTree::getNodeCount | ( |  | ) | const
| inline

node count

Definition at line 85 of file btGImpactQuantizedBvh.h.

## ◆ getNodeData()

int btQuantizedBvhTree::getNodeData | ( | int | nodeindex | ) | const
| inline

Definition at line 96 of file btGImpactQuantizedBvh.h.

## ◆ getRightNode()

int btQuantizedBvhTree::getRightNode | ( | int | nodeindex | ) | const
| inline

Definition at line 132 of file btGImpactQuantizedBvh.h.

## ◆ isLeafNode()

bool btQuantizedBvhTree::isLeafNode | ( | int | nodeindex | ) | const
| inline

tells if the node is a leaf

Definition at line 91 of file btGImpactQuantizedBvh.h.

## ◆ quantizePoint()

void btQuantizedBvhTree::quantizePoint | ( | unsigned short * | quantizedpoint,
|  | const btVector3 & | point
| ) |  | const
| inline

Definition at line 65 of file btGImpactQuantizedBvh.h.

## ◆ setNodeBound()

void btQuantizedBvhTree::setNodeBound | ( | int | nodeindex,
|  | const btAABB & | bound
| ) |  |
| inline

Definition at line 112 of file btGImpactQuantizedBvh.h.

## ◆ testQuantizedBoxOverlapp()

bool btQuantizedBvhTree::testQuantizedBoxOverlapp | ( | int | node_index,
|  | unsigned short * | quantizedMin,
|  | unsigned short * | quantizedMax
| ) |  | const
| inline

Definition at line 71 of file btGImpactQuantizedBvh.h.

## Member Data Documentation

## ◆ m_bvhQuantization

btVector3 btQuantizedBvhTree::m_bvhQuantization
| protected

Definition at line 42 of file btGImpactQuantizedBvh.h.

## ◆ m_global_bound

btAABB btQuantizedBvhTree::m_global_bound
| protected

Definition at line 41 of file btGImpactQuantizedBvh.h.

## ◆ m_node_array

GIM_QUANTIZED_BVH_NODE_ARRAY btQuantizedBvhTree::m_node_array
| protected

Definition at line 40 of file btGImpactQuantizedBvh.h.

## ◆ m_num_nodes

int btQuantizedBvhTree::m_num_nodes
| protected

Definition at line 39 of file btGImpactQuantizedBvh.h.

The documentation for this class was generated from the following files:

- btGImpactQuantizedBvh.h
- btGImpactQuantizedBvh.cpp